package com.example.youtube_videos;


import java.lang.ref.WeakReference;
import java.util.logging.Logger;

import com.example.youtube_videos.model.UserDetail;
import com.example.youtube_videos.util.Util;

import android.os.AsyncTask;

// ASYNC processing
public class GetUserDetailAsyncTask extends AsyncTask<String, Void, UserDetail> {

	// used to return the result
	private WeakReference<IDataAccessor> dataAccessor; // QUESTION - why are we using WeakReference?
	
	private Logger log = Logger.getLogger(GetUserDetailAsyncTask.class.getName());
	
	
	
	public GetUserDetailAsyncTask(IDataAccessor dataAccessor) {
		super();
		attach(dataAccessor);
	}
	
	public void attach(IDataAccessor dataAccessor) {
		// reattaching new consumer of the result
		this.dataAccessor = new WeakReference<IDataAccessor>(dataAccessor); 
	}

	@Override
	protected UserDetail doInBackground(String... arg0) {
		// this function runs in a worker thread
		UserDetail ud = null;
		try {
			String response = Util.downloadUserDetail(arg0[0]);
			return Util.parseUserDetail(response);
		} catch(Exception e) {
			log.severe("An exception occurred: " + e.getMessage());
		}
		return ud;
	}

	@Override
	protected void onPostExecute(UserDetail result) {
		// runs in the main thread after the background processing has ended
		super.onPostExecute(result);
		if(dataAccessor != null && dataAccessor.get() != null)
			dataAccessor.get().setUserDetail(result);
	}


}
